unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MyFunc, JwwGaibu ;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit3: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit4: TEdit;
    Label8: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    AppPath : string ;
    p1,p2 : integer ;
    p3,p4,p5 : double ;
    procedure OpenDatFile ;
    procedure SaveDatFile ;
  public
    { Public 錾 }
    procedure Line2(id,n:integer; s,x,y,l,a,b:double);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile ;
var
   fn: string ;
   F : TextFile ;
   s : string ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   p1 := 4 ;
   p2 := 0 ;
   p3 := 45.0;
   p4 := 100.0;
   p5 := 1.0;
   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, s);     p1 := SInt(s);
      ReadLn(F, s);     p2 := SInt(s);
      ReadLn(F, s);     p3 := SDbl(s);
      ReadLn(F, s);     p4 := SDbl(s);
      ReadLn(F, s);     p5 := SDbl(s);

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile ;
var
   fn: string ;
   F : TextFile ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, IntToStr(p1));
      WriteLn(F, IntToStr(p2));
      WriteLn(F, FloatToStr(p3));
      WriteLn(F, FloatToStr(p4));
      WriteLn(F, FloatToStr(p5));

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then DeleteFile(fn);
   end;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   Form1.Left := Mouse.CursorPos.X - Form1.Width div 2;
   Form1.Top  := Mouse.CursorPos.Y - 4;
   if (Form1.Left < Form1.Monitor.Left) then Form1.Left := Form1.Monitor.Left ;
   if (Form1.Top  < Form1.Monitor.Top ) then Form1.Top  := Form1.Monitor.Top  ;
   if (Form1.Left > (Form1.Monitor.Left+Form1.Monitor.Width -Form1.Width)) then
      Form1.Left :=  Form1.Monitor.Left+Form1.Monitor.Width -Form1.Width  ;
   if (Form1.Top  > (Form1.Monitor.Top +Form1.Monitor.Height-Form1.Height)) then
      Form1.Top  :=  Form1.Monitor.Top +Form1.Monitor.Height-Form1.Height ;
   // ݒ
   InitJwwGaibu ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // JWC_TEMP.TXTJ܂
   OpenTempFile(AppPath+'JWC_TEMP.TXT') ;
   // ݒ
   OpenDatFile ;

   RadioButton1.Checked := True ;
   if (p2 <> 0) then
      RadioButton2.Checked := True ;

   Edit1.Text := IntToStr(p1);
   Edit2.Text := FloatToStr(p3);
   Edit3.Text := FloatToStr(p4);
   Edit4.Text := FloatToStr(p5);
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // JWC_TEMP.TXTۑ܂
   SaveTempFile(AppPath+'JWC_TEMP.TXT') ;
   // ŏI
   EndJwwGaibu ;
end;

// [OK]
procedure TForm1.Button1Click(Sender: TObject);
var
   x1,y1,x2,y2,l,a : double ;
begin
   p1 := SInt(Edit1.Text);
   p3 := SDbl(Edit2.Text);
   p4 := SDbl(Edit3.Text);
   p5 := SDbl(Edit4.Text);
   p2 := 0 ;
   if (RadioButton2.Checked) then p2 := 1;
   if (p1 < 1) or (p1 > 15) then begin
      Edit1.SetFocus ;
      exit;
   end;
   if (p3 <= 0.0) or (p3 >= 360.0) then begin
      Edit2.SetFocus ;
      exit;
   end;
   if (p4 <= 0.0) then begin
      Edit3.SetFocus ;
      exit;
   end;
   if (p5 <= 0.0) then begin
      Edit4.SetFocus ;
      exit;
   end;
   SaveDatFile ;

   x1 := JG_IPoints[1].x ;
   y1 := JG_IPoints[1].y ;
   x2 := JG_IPoints[2].x ;
   y2 := JG_IPoints[2].y ;
   if (p2 = 0) then
      l := Dist(x1,y1,x2,y2) / p1
   else
      l := p4 ;
   a  := Angle(x2-x1,y2-y1);

   // 
   S_Init ;             // 
   S_LGrp(JG_CurLGrp);  // CO[v
   S_Lay(JG_CurLay);    // C
   S_Col(JG_CurCol,0);  // F
   S_Ltp(JG_CurLtp,0);  // 
   S_Wid(JG_CurWid);    // 

   x2 := x1 + l*Cos(a);
   y2 := y1 + l*Sin(a);
   S_Line(x1,y1, x2,y2);
   Line2(2,p1, p5,x2,y2,l*p5,a,p3/180.0*Pi);

   Close ;
end;

// [Cancel]
procedure TForm1.Button2Click(Sender: TObject);
begin
   Close ;
end;

procedure TForm1.Line2(id,n:integer; s,x,y,l,a,b:double);
var
   x1,y1,x2,y2 : double ;
begin
   if (id > n) then exit ;

   x1 := x + l*Cos(a+b);
   y1 := y + l*Sin(a+b);
   x2 := x + l*Cos(a-b);
   y2 := y + l*Sin(a-b);
   S_Line(x,y, x1,y1);
   S_Line(x,y, x2,y2);

   Line2(id+1,n, s,x1,y1,l*s,a+b,b);
   Line2(id+1,n, s,x2,y2,l*s,a-b,b);
end;

end.
